﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

using Syncfusion.DocIO.DLS;
using System.ComponentModel;
using Syncfusion.DocIO;

using System.Web;
using System.IO;
using System.Data;
using System.Collections;


namespace ConsoleApplication1
{
    class Program
    {


        static void Main(string[] args)
        {
            string fileName = @"..\..\Documents\Donor Annual Statement_new.docx";
            string GetDirectoryName = AppDomain.CurrentDomain.BaseDirectory;
            string path = Path.Combine(GetDirectoryName, fileName);
            //Opens the template document
            WordDocument document = new WordDocument(path);
            //Get the data set for execution
            DataSet dataSet = GetDataSet();
            ArrayList commands = new ArrayList();
            //Add the Account table to command array
            DictionaryEntry entry = new DictionaryEntry("Account", string.Empty);
            commands.Add(entry);
            //Add the AccountInfo table command array
            entry = new DictionaryEntry("AccountInfo", "AccountNumber = %Account.AccountNumber%");
            commands.Add(entry);
            //Perform the mail merge
            document.MailMerge.ClearFields = false;
            document.MailMerge.ExecuteNestedGroup(dataSet, commands);
            
            try
            {
                //Saving the document as .docx
                document.Save( Path.Combine(GetDirectoryName, @"Documents\GenerateWord.docx"), FormatType.Word2010);

            }
            catch (Win32Exception ex)
            {
                Console.WriteLine(ex.ToString());
            }
        }

        static WTableRow GetTableRow(Entity entity)
        {
            //Checks until WTable entity
            while (!(entity is WTableRow))
            {
                if (entity.Owner != null)
                    entity = entity.Owner;
                else
                    break;
            }
            return entity as WTableRow;
        }
        static DataTable GetAccountTable()
        {
            DataTable dt = new DataTable();
            dt.TableName = "Account";
            dt.Columns.Add("AccountNumber");
            DataRow row = dt.Rows.Add();
            row["AccountNumber"] = "A-111111";
            row = dt.Rows.Add();
            row["AccountNumber"] = "A-222222";
            
            row = dt.Rows.Add();
            row["AccountNumber"] = "A-333333";
            
            row = dt.Rows.Add();
            row["AccountNumber"] = "A-444444";
            
            row = dt.Rows.Add();
            row["AccountNumber"] = "A-555555";
            
            return dt;
        }
        static DataTable GetAccountInfo()
        {
            DataTable dt = new DataTable();
            dt.TableName = "AccountInfo";
            dt.Columns.Add("AccountNumber");
            dt.Columns.Add("AccountDate");
            dt.Columns.Add("AccountReference");
            dt.Columns.Add("AccountDetails");
            dt.Columns.Add("AccountAmount");
            //First account
            //1
            DataRow row = dt.Rows.Add();
            row["AccountNumber"] = "A-111111";
            row["AccountDate"] = "09/10/2015";
            row["AccountReference"] = "";
            row["AccountDetails"] = "Opening Balance";
            row["AccountAmount"] = "355";
            
            //2
            row = dt.Rows.Add();
            row["AccountNumber"] = "A-111111";
            row["AccountDate"] = "10/10/2015";
            row["AccountReference"] = "";
            row["AccountDetails"] = "Opening Balance";
            row["AccountAmount"] = "355";
            
            //3
            row = dt.Rows.Add();
            row["AccountNumber"] = "A-111111";
            row["AccountDate"] = "11/10/2015";
            row["AccountReference"] = "";
            row["AccountDetails"] = "Opening Balance";
            row["AccountAmount"] = "355";
            
            //4
            row = dt.Rows.Add();
            row["AccountNumber"] = "A-111111";
            row["AccountDate"] = "12/10/2015";
            row["AccountReference"] = "";
            row["AccountDetails"] = "Opening Balance";
            row["AccountAmount"] = "355";
            
            //5
            row = dt.Rows.Add();
            row["AccountNumber"] = "A-111111";
            row["AccountDate"] = "13/10/2015";
            row["AccountReference"] = "";
            row["AccountDetails"] = "Opening Balance";
            row["AccountAmount"] = "355";
            
            //Second account
            row = dt.Rows.Add();
            row["AccountNumber"] = "A-222222";
            row["AccountDate"] = "09/10/2015";
            row["AccountReference"] = "";
            row["AccountDetails"] = "Opening Balance";
            row["AccountAmount"] = "355";
            
            //2
            row = dt.Rows.Add();
            row["AccountNumber"] = "A-222222";
            row["AccountDate"] = "10/10/2015";
            row["AccountReference"] = "";
            row["AccountDetails"] = "Opening Balance";
            row["AccountAmount"] = "355";
            
            //3
            row = dt.Rows.Add();
            row["AccountNumber"] = "A-222222";
            row["AccountDate"] = "11/10/2015";
            row["AccountReference"] = "";
            row["AccountDetails"] = "Opening Balance";
            row["AccountAmount"] = "355";
            
            //4
            row = dt.Rows.Add();
            row["AccountNumber"] = "A-222222";
            row["AccountDate"] = "12/10/2015";
            row["AccountReference"] = "";
            row["AccountDetails"] = "Opening Balance";
            row["AccountAmount"] = "355";
            
            //5
            row = dt.Rows.Add();
            row["AccountNumber"] = "A-222222";
            row["AccountDate"] = "13/10/2015";
            row["AccountReference"] = "";
            row["AccountDetails"] = "Opening Balance";
            row["AccountAmount"] = "355";
            
            //third account
            row = dt.Rows.Add();
            row["AccountNumber"] = "A-333333";
            row["AccountDate"] = "09/10/2015";
            row["AccountReference"] = "";
            row["AccountDetails"] = "Opening Balance";
            row["AccountAmount"] = "355";
            
            //2
            row = dt.Rows.Add();
            row["AccountNumber"] = "A-333333";
            row["AccountDate"] = "10/10/2015";
            row["AccountReference"] = "";
            row["AccountDetails"] = "Opening Balance";
            row["AccountAmount"] = "355";
            
            //3
            row = dt.Rows.Add();
            row["AccountNumber"] = "A-333333";
            row["AccountDate"] = "11/10/2015";
            row["AccountReference"] = "";
            row["AccountDetails"] = "Opening Balance";
            row["AccountAmount"] = "355";
            
            //4
            row = dt.Rows.Add();
            row["AccountNumber"] = "A-333333";
            row["AccountDate"] = "12/10/2015";
            row["AccountReference"] = "";
            row["AccountDetails"] = "Opening Balance";
            row["AccountAmount"] = "355";
            
            //5
            row = dt.Rows.Add();
            row["AccountNumber"] = "A-333333";
            row["AccountDate"] = "13/10/2015";
            row["AccountReference"] = "";
            row["AccountDetails"] = "Opening Balance";
            row["AccountAmount"] = "355";
            
            //fourth account
            row = dt.Rows.Add();
            row["AccountNumber"] = "A-444444";
            row["AccountDate"] = "09/10/2015";
            row["AccountReference"] = "";            
            row["AccountDetails"] = "Opening Balance";
            row["AccountAmount"] = "355";
            
            //2
            row = dt.Rows.Add();
            row["AccountNumber"] = "A-444444";
            row["AccountDate"] = "10/10/2015";
            row["AccountReference"] = "";
            row["AccountDetails"] = "Opening Balance";
            row["AccountAmount"] = "355";
            
            //3
            row = dt.Rows.Add();
            row["AccountNumber"] = "A-444444";
            row["AccountDate"] = "11/10/2015";
            row["AccountReference"] = "";
            row["AccountDetails"] = "Opening Balance";
            row["AccountAmount"] = "355";
            
            //4
            row = dt.Rows.Add();
            row["AccountNumber"] = "A-444444";
            row["AccountDate"] = "12/10/2015";
            row["AccountReference"] = "";
            row["AccountDetails"] = "Opening Balance";
            row["AccountAmount"] = "355";
            
            //5
            row = dt.Rows.Add();
            row["AccountNumber"] = "A-444444";
            row["AccountDate"] = "13/10/2015";
            row["AccountReference"] = "";
            row["AccountDetails"] = "Opening Balance";
            row["AccountAmount"] = "355";
            
            //Fifth account
            row = dt.Rows.Add();
            row["AccountNumber"] = "A-555555";
            row["AccountDate"] = "09/10/2015";
            row["AccountReference"] = "";
            row["AccountDetails"] = "Opening Balance";
            row["AccountAmount"] = "355";
            
            //2
            row = dt.Rows.Add();
            row["AccountNumber"] = "A-555555";
            row["AccountDate"] = "10/10/2015";            
            row["AccountReference"] = "";
            row["AccountDetails"] = "Opening Balance";
            row["AccountAmount"] = "355";
            
            //3
            row = dt.Rows.Add();
            row["AccountNumber"] = "A-555555";
            row["AccountDate"] = "11/10/2015";
            row["AccountReference"] = "";
            row["AccountDetails"] = "Opening Balance";
            row["AccountAmount"] = "355";
            
            //4
            row = dt.Rows.Add();
            row["AccountNumber"] = "A-555555";
            row["AccountDate"] = "12/10/2015";
            row["AccountReference"] = "";
            row["AccountDetails"] = "Opening Balance";
            row["AccountAmount"] = "355";
            
            //5
            row = dt.Rows.Add();
            row["AccountNumber"] = "A-555555";
            row["AccountDate"] = "13/10/2015";
            row["AccountReference"] = "";
            row["AccountDetails"] = "Opening Balance";
            row["AccountAmount"] = "355";
            
            return dt;
        }
        static DataSet GetDataSet()
        {
            DataSet ds = new DataSet();
            ds.Tables.Add(GetAccountTable());
            ds.Tables.Add(GetAccountInfo());
            return ds;
        }
    }
}
